
import org.gcube.application.cms.cataloguebinding.CatalogueBindingPlugin;
import org.gcube.application.cms.cataloguebinding.EventsSubscribed;
import org.gcube.application.cms.plugins.faults.InitializationException;
import org.gcube.application.cms.tests.TestProfiles;
import org.gcube.application.cms.tests.plugins.BasicPluginTest;
import org.gcube.application.geoportal.common.model.useCaseDescriptor.UseCaseDescriptor;
import org.gcube.application.geoportal.common.utils.tests.GCubeTest;
import org.junit.Test;

public class CatalogueBindingPluginTest extends BasicPluginTest {

	//@Test
	public void checkPlugin() {
		org.junit.Assume.assumeTrue(GCubeTest.isTestInfrastructureEnabled());
		CatalogueBindingPlugin plugin = (CatalogueBindingPlugin) plugins.get(CatalogueBindingPlugin.DESCRIPTOR.getId());

		try {
			plugin.init();
		} catch (InitializationException e1) {
			e1.printStackTrace();
		}
		try {
			plugin.initInContext();
		} catch (InitializationException e1) {
			e1.printStackTrace();
		}

		System.out.println("Plugin check: " + plugin);

	}

	@Test
	public void checkPluginConfig() {
		org.junit.Assume.assumeTrue(GCubeTest.isTestInfrastructureEnabled());
		CatalogueBindingPlugin plugin = (CatalogueBindingPlugin) plugins.get(CatalogueBindingPlugin.DESCRIPTOR.getId());
		UseCaseDescriptor descriptor = TestProfiles.profiles.get("profiledConcessioni");

		try {
			plugin.init();
		} catch (InitializationException e1) {
			e1.printStackTrace();
		}
		try {
			plugin.initInContext();
		} catch (InitializationException e1) {
			e1.printStackTrace();
		}

		EventsSubscribed events;
		try {
			events = plugin.readEventsSubscribedFromConfigurationInTheUCD(descriptor);
			System.out.println("Events: " + events);
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
